'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (loadModule) {
	var Bundle = function (_Component) {
		_inherits(Bundle, _Component);

		_createClass(Bundle, null, [{
			key: 'preload',
			value: function preload() {
				loadModule.default.load(function () {});
			}
		}]);

		function Bundle() {
			_classCallCheck(this, Bundle);

			var _this = _possibleConstructorReturn(this, (Bundle.__proto__ || Object.getPrototypeOf(Bundle)).apply(this, arguments));

			_this.state = {
				mod: null
			};
			if (process.env.SIDE === 'server') {
				console.log(loadModule.default.component.default);
				_this.state = {
					mod: loadModule.default.component.default
				};
				_this.props.client.registerChunk(loadModule.default.chunkName);
			} else if (process.env.SIDE === 'client') {
				var id = loadModule.default.id;
				if (_this.hasModule(id)) {
					_this.state = {
						mod: __webpack_require__(id).default
					};
				} else {
					_this.state = {
						mod: null
					};
				}
			}
			return _this;
		}

		_createClass(Bundle, [{
			key: 'hasModule',
			value: function hasModule(id) {
				return !!__webpack_modules__[id];
			}
		}, {
			key: 'componentDidMount',
			value: function componentDidMount() {
				if (process.env.SIDE === 'client') {
					var id = loadModule.default.id;
					if (!this.hasModule(id)) {
						this.load(this.props);
					}
				}
			}
		}, {
			key: 'load',
			value: function load(props) {
				var _this2 = this;

				loadModule.default.load(function (mod) {
					_this2.setState({
						mod: mod.default ? mod.default : mod
					});
				});
			}
		}, {
			key: 'render',
			value: function render() {
				var Component = this.state.mod;
				return Component ? _react2.default.createElement(Component, this.props) : null;
			}
		}]);

		return Bundle;
	}(_react.Component);

	Bundle.propTypes = {};

	var mapStateToProps = function mapStateToProps(state) {
		return {
			client: getClient(state)
		};
	};

	return App.connect(mapStateToProps)(Bundle);
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
